import { AutoScalingGroup } from '@aws-cdk/aws-autoscaling';
import { Cluster } from '@aws-cdk/aws-eks';
import { Construct } from '@aws-cdk/core';
/**
 * @stability stable
 */
export interface CertManagerProps {
    /**
     * @stability stable
     */
    readonly cluster: Cluster;
    /**
     * @stability stable
     */
    readonly nodegroup: AutoScalingGroup;
    /**
     * @stability stable
     */
    readonly namespace: String;
    /**
     * @stability stable
     */
    readonly cacertname: String;
    /**
     * @stability stable
     */
    readonly dnsNames: String[];
    /**
     * @stability stable
     */
    readonly hostedZoneName: string;
    /**
     * @stability stable
     */
    readonly clusterIssuerName: String;
    /**
     * @stability stable
     */
    readonly privateCaArn: string;
}
/**
 * @stability stable
 */
export declare class CertManager extends Construct {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, props: CertManagerProps);
}
